;-------------------------------------------------------------------------

;   The FIRMWARE for KISS TNC by Denis Nechitailov  1996

;       (for  Micro Series 8051 Assembler V2.02/DOS)

;  KISS TNC K469

; Open:   23.9.1999

;-------------------------------------------------------------------------

; 塠 ᫠:  ᤥ ࠭ ᭠砫 襣 , ⥬
; 襣,  dw - : ᭠砫 訩, ⥬ 訩

;-------------------------------------------------------------------------

;  ⠭

RAM_SIZE        =       8192    ; ꥬ 

FLAG            =       01111110b       ;  AX.25-
BS              =       5               ;   ᫥ . 
                                        ;  -䨭

;-------------------------------------------------------------------------

; 樠   KISS-

FEND    =       0C0h    ; Frame End
FESC    =       0DBh    ; Frame Escape
TFEND   =       0DCh    ; Transposed Frame End
TFESC   =       0DDh    ; Transposed Frame Escape

;   KISS- ( ࠤ )
; * -   ন

PARAM_DATA      =       0
PARAM_TXDELAY   =       1
PARAM_PERSIST   =       2
PARAM_SLOTTIME  =       3
PARAM_TXTAIL    =       4
PARAM_FULLDUP   =       5 ;*
PARAM_SETHARDW  =       6 ;*
PARAM_RETURN    =       0Fh    ;  १ watchdog

;-------------------------------------------------------------------------

;  ⠭,    १/᪮⥩

;       FQ      -  १, 
;       BAUD    - ᪮ ࠡ  ࠤ, 
;       ASYNC   - ᪮ ࠡ  ⮬, 

; ᫮ ⨪ ⠩  ६ 10 
; U_TICK        =       FQ*10/12/1000

U_TICK  =       2400h 	;11.0592
;U_TICK  =       10000 	;12.000

; ᫮ ,   ।  ६ 10 
; BPU   =       10*BAUD/1000

BPU1200 =       12
BPU2400 =       24
BPU4800 =       48

; ⠭  ⠩ 1 (᫥⥫ , ०  ⮯१㧪)
; T1_CONST =    256-FQ/(ASYNC*192)

;T1_CONST      =       0FDh      ; 11.059.200 / 19200
;T1_CONST      =       0D5h      ; 19.660.800 / 2400
;T1_CONST      =       256-35      ; 16.000.000 / 2400

T1_CONST      =       0FAh      ; 11.059.200 / 9600
;T1_CONST      =       0F3h      ; 12.000.000 / 4800

;-------------------------------------------------------------------------

; ७  

; । ᮢ:
;
;   ॣ ( 0)
;   ⥪
;   ६ ணࠬ:
;         ६
;        ॡ騥 樠樨  ᨬ  ਠ

dstart  rseg    DATA
;        org     dstart+44
        org     dstart+50

; ஢ઠ ९ ⥪

stk_check       ds      2       ;   ᫥  ⥪ -   0FFh

; ⥫

tx_pro_head     ds      2       ; ⥫  ०   ।饬 
tx_head         ds      2       ; ⥫    ।饬 
tx_tail         ds      2       ; ⥫  墮  ।饬 

rx_pro_head     ds      2       ; ⥫  ०   ਥ 
rx_head         ds      2       ; ⥫    ਥ 
rx_tail         ds      2       ; ⥫  墮  ਥ 


; ६ ﭨ ஫

bits            ds      1       ; ⢮ ਭ/। 
cap             ds      1       ; ਭ/। 
capm1           ds      1       ; ਭ/।  . ࠧ
capm2           ds      1       ; ਭ/।  ।. ࠧ

rnd             ds      1       ; 砩 ᫮ -  ࠢ  persist

; ६ ﭨ ਥ KISS-  

in_state        ds      1       ; ﭨ ਥ KISS-  
        IS_NORMAL       = 0     ;  ᨬ - 
        IS_FESC         = 1     ;  ᨬ - FESC

tx_state        ds      1       ; ﭨ । AX.25-  
        TX_NONE         = 0     ;   
        TX_NORMAL       = 1     ;  

true_flag       ds      1       ; ⢨⥫쭮  ⨬ । 䫠?
        FLAG_NO         = 0
        FLAG_YES        = 1

in_type         ds      1       ;  ਭ⮣   KISS-
in_value        ds      1       ; 祭 ࠬ KISS-, ᫨  ࠢ騩

; ६ ﭨ । KISS-  

out_order       ds      1       ; ﭨ । KISS-
        OUT_BUSY        = 0     ; ।  뢠
        OUT_FREE        = 1     ; 뢠 

out_state       ds      1       ; ﭨ । KISS-
        OS_NONE         = 0
        OS_1FEND        = 1
        OS_TFEND        = 2
        OS_TFESC        = 3
        OS_NORMAL       = 4

; ६ ﭨ ਥ AX.25-

rxsy_cntr       ds      1       ; 稪  ਭ 
rxsy_lastbit    ds      1       ; ᫥ ਭ 

; ६ ० ࠡ ஫

mode            ds      1       ;  ࠡ ஫
        M_RX    =       0       ; ਥ
        M_TX    =       1       ; ।
        M_TXD   =       2       ; txdelay
        M_TXT   =       3       ; txtail


u_keep          ds      2       ;  ⠩ 0    ᫥
                                ; ७ ( slottime)

; ६ 稪

slottime_count  ds      2       ; 稪 ਮ  slottime
txdelay_count   ds      2       ; 稪   txdelay
txtail_count    ds      2       ; 稪   txtail

;

any             ds      1       ; ⮢    ।?
        ANY_NO  =       0       ; H
        ANY_YES =       1       ; 

;

to_count        ds      1       ; ᫮ ⠪⮢,  㦭 
                                ;  ।, ० 祬  室 ᨣ

tx_crc          ds      2       ; CRC । 

rx_crc          ds      2       ; CRC ਭ 
rx_crcm1        ds      2       ; CRC ਭ  ᫥ ࠧ
rx_crcm2        ds      2       ; CRC ਭ  ।᫥ ࠧ

wr_tx_count     ds      2       ; 稪     ।騩 
;ds 1
wr_rx_count     ds      2       ; 稪     ਥ 
;ds 1
rd_tx_count     ds      2       ; 稪   ⥭  ।饣 
;ds 1
rd_rx_count     ds      2       ; 稪   ⥭  ਥ 
;ds 1

tx_addrlen      ds      2       ;   뢠   । 
rx_addrlen      ds      2       ;   뢠   ਥ 

order_txbuf     ds      1       ;   ?
        BUF_FREE        = 0
        BUF_FULL        = 1
order_rxbuf     ds      1       ;   ?

rb_buf          ds      1       ;  ਭ 
rb_cntr         ds      1       ; 稪
rb_buf_old      ds      1       ;  ਭ 
rb_cntr_old     ds      1       ; 稪

;-------------------------------------------------------------------------

; ६, ॡ騥 樠樨  ᨬ  ᪮

; ६ - ࠬ 裡

txdelay         ds      1       ; 祭 txdelay   ࢠ 10 
persist         ds      1       ; 祭 persist
slottime        ds      1       ; 祭 slottime  ࢠ 10 
txtail          ds      1       ; 祭 txtail    ࢠ 10 


; ᫮ ⨪ ⠩  ६ ਥ/।     ० RX
p_tick_rx       ds      2

; ᫮ ⨪ ⠩  ६ ਥ/।     ० RX
p_tick_rx2      ds      2

; ᫮ ⨪ ⠩  ६ 10 
u_tick          ds      2

; ᫮ ,   ।  ६ 10 
bpu             ds      1

is_psk          ds      1       ;  PSK-०

;-------------------------------------------------------------------------

; । ᮢ 譥  
;   室  横᪨  -  ਥ  ।.
;  ࠬ ६ 㪠⥫:
; ᭠砫  *_pro_head, ⥬ *_head, ⥬ *_tail, 祬 *_pro_head
; 㦥  ०饩 , ⮡   ணࠬ  
; ਭ ,  㣠    ᠫ ,
;  뢠  뢠   ,  
; *_head = *_pro_head,  ⮣     짮

;  ࠭  :
; <N= 2     CRC> <N  AX.25 ,  2  CRC>

; 樨: ⥭,  , ⨥, 

        rseg    XDATA

BUF_SIZE        =       4096    ;  ஢ - ⮫쪮 2^N !

tx_buf          ds      BUF_SIZE  ; ।騩  AX.25
tx_buf_end      =       $

rx_buf          ds      BUF_SIZE  ; ਥ  AX.25
rx_buf_end      =       $

;-------------------------------------------------------------------------

; 譨 ᨣ

NRZI    =       p1.0    ; 室  FX469
NRZO    =       p1.1    ; 室  FX469, watchdog
PTT     =       p1.2    ; Push to talk, 0=⨢
DCDIN   =       p1.3    ; 室 DCD

; 祭  

DCD     =       p1.4    ; 室 DCD  , 1-⨢
DTR     =       p1.5    ; 室 DTR  , 0-⨢
CTS     =       p1.6    ; 室 CTS, 0-⨢
RTS     =       p1.7    ; 室 RTS, 0-⨢

; 室 ᨣ - 롮 ᪮

K0      =       p3.4    ; 1200/2400
K1      =       p3.5    ; 4800

;
;       1200    2400    4800
;
; K0    1       0       0
; K1    0       0       1
;

;-------------------------------------------------------------------------

;  ணࠬ

start   rseg    CODE

;  뢠

        org     start
        jmp     main_start      ; H 砫 ணࠬ

        org     start+3
        jmp     int_txsy  ; 뢠 ।稪 FX469

        org     start+0Bh
        reti            ; 뢠  ⠩ 0

        org     start+13h
        jmp     int_rxsy  ; 뢠 ।稪 FX469

        org     start+1Bh
        reti            ; 뢠  ⠩ 1  - 窠

        org     start+23h
        jmp     int_art ; 뢠  ᫥. 

;-------------------------------------------------------------------------

; H,   

brag = $
        db      13,10,13,10
        db      'KISS TNC firmware (K469) by Denis Nechitailov, UU9JDR'
        db      13,10,13,10

;-------------------------------------------------------------------------

; , 믮騩 ।⢥

main_start:

        clr     EA      ;  ஢ 뢠
        mov     SP,#4

        call    check_ram       ; ஢塞 
        call    init            ; ⠭
;        call    init            ; ⠭

        setb    EA

; ᭮ 横

loop:

; 砫 ࠧࠥ  ࠢ묨   ⠬

        mov     a,out_order     ;    뢠 뫠   ?
        cjne    a,#OUT_FREE,sc ; H, ।  ᠬ  뢠

        call    a_tx    ; , 㥬 뫪

sc:

; ࠡ⪠    , ਭ  FX469

;        call    rb_all


;  ஢塞 ⥪  । ९

        call    check_stack

;  ० । - 塞 ᭮ 横

        mov     a,mode  ;  ࠡ ஫
        cjne    a,#M_RX,loop    ;  ࠡ⠥ ⮫쪮  ० ਥ

        cpl     NRZO    ; H ᨬ...

        jnb     DCDIN,nodcd     ;   

; H  - 室  । 

        mov     slottime_count,#0       ; 塞 稪 slottime
        jmp     loop

; H饩  - ⮢  ४祭  ।

nodcd:

        mov     a,any ;   ⮢   ।?
        cjne    a,#ANY_YES,loop ; ᫨ 祣  ⮢ -   ४砥

        mov     a,slottime_count        ; 稪 slottime
        jz      sl_finished     ; ⠫  ?

; H, ⠥

; 諮  ६ 10  ?

        clr     TR0             ; 騥  ⠩
        mov     dpl,tl0
        mov     dph,th0
        setb    TR0

        clr     c               ; 塞 ࠧ 
        mov     a,dpl
        xrl     rnd,a           ; ନ㥬 砩 ᫮
        subb    a,u_keep
        mov     r0,a
        mov     a,dph
        subb    a,u_keep+1
        mov     r1,a

        clr     c               ; ࠢ  ࢠ  10 
        mov     a,r0
        subb    a,u_tick
        mov     a,r1
        subb    a,u_tick+1

        jc      loop    ;  ,  ⠥ slottime

; ६ 諮

        mov     u_keep,dpl      ;  ⥪騥 
        mov     u_keep+1,dph


        dec     slottime_count ; ६ 10  諮 -  ⠪
        jmp     loop

sl_finished:

        mov     a,persist       ; ࠢ persist  砩 ᫮
        clr     c
        subb    a,rnd
        jc      fault   ; ᫨ persist < rnd - 㤠

; ४砥  ।!!!

        clr     EA      ; 뢠 - 頥
        clr     TR0

        clr     PTT     ; ࠭ᨢ -  ।

        mov     a,txdelay       ; 뢠 ᫮ , ஥
                                ;   txdelay
        mov     b,bpu
        mul     ab
        mov     txdelay_count,a ; txdelay   砫 
        mov     txdelay_count+1,b

        mov     a,txtail        ; 뢠 ᫮ , ஥
                                ;   txtail
        mov     b,bpu
        mul     ab
        mov     txtail_count,a  ; txtail   砫 
        mov     txtail_count+1,b

        mov     mode,#M_TXD     ;  ࠡ - ନ஢ txdelay

        mov     to_count,#1     ; ⬥塞 ६

        mov     bits,#0         ;  祣  ।

        mov     true_flag,#FLAG_YES     ;  砫 । ⢨⥫쭮 䫠

        setb    TR0           ; 뢠 ࠧ蠥
        setb    EA

        jmp     loop    ;  横

fault:
        clr     TR0     ; ஭㥬  10- 
        mov     u_keep,tl0
        mov     u_keep+1,th0
        setb    TR0
        mov     slottime_count,slottime ; ⠥ slottime 

        jmp     loop

;-------------------------------------------------------------------------

;if 0=1

; ஭ ਥ FX469 - 뢠 INT1

int_rxsy:


        push    psw
        push    acc

        mov     a,mode          ; 믮塞 ⮫쪮  ० ਥ
        cjne    a,#M_RX,rxsy_cannot
        jmp     rxsy_rx
rxsy_cannot:
        jmp     rxsy_exit

rxsy_rx:
        push    b
        push    0       ; push r0
        push    1       ; push r1
        push    dph
        push    dpl

; ࠥ  PSK

        mov     a,is_psk
        jz      rxsy_npsk

        jb      NRZI,rxsy_changed       ; '1' (. ⮭) - ஢ 
        jmp     rxsy_notchanged         ; '0' (. ⮭) -  

rxsy_npsk:
        mov     a,rxsy_lastbit
        jb      NRZI,rxsy_1     ; 室 ᨣ

        ; ਭ  = 0

        jz      rxsy_notchanged
        jmp     rxsy_changed

rxsy_1:
        ; ਭ  = 1
        jnz     rxsy_notchanged
        jmp     rxsy_changed


; ਭ  ⠪ ,  ।騩

rxsy_notchanged:
        inc     rxsy_cntr       ;  ...
        jmp     rxsy_rxdone

; 室 ஢  - ࠡ뢠

rxsy_changed:

        cpl     a
        anl     a,#1
        mov     rxsy_lastbit,a

        mov     a,rxsy_cntr     ; 稪 
        mov     rxsy_cntr,#1

;jmp rxsy_rxdone

;  ᨬ  ⢠   뢠   ᪮쪮 

        cjne    a,#1,rxsy_g1
        mov     r0,#0
        mov     r1,#1
        jmp     rxsy_rxwrite     ; ਭ : 0 (0.5<t<1.5)

rxsy_g1:
        cjne    a,#2,rxsy_g2
        mov     r0,#01b
        mov     r1,#2
        jmp     rxsy_rxwrite     ; ਭ : 01 (1.5<t<2.5)

rxsy_g2:
        cjne    a,#3,rxsy_g3
        mov     r0,#011b
        mov     r1,#3
        jmp     rxsy_rxwrite     ; ਭ : 011 (2.5<t<3.5)

rxsy_g3:
        cjne    a,#4,rxsy_g4
        mov     r0,#0111b
        mov     r1,#4
        jmp     rxsy_rxwrite     ; ਭ : 0111 (3.5<t<4.5)

rxsy_g4:
        cjne    a,#5,rxsy_g5
        mov     r0,#01111b
        mov     r1,#5
        jmp     rxsy_rxwrite     ; ਭ : 01111 (4.5<t<5.5)

rxsy_g5:
        cjne    a,#6,rxsy_g6
        mov     r0,#11111b
        mov     r1,#5
        jmp     rxsy_rxwrite     ; ਭ : 11111 (5.5<t<6.5), -䨭

rxsy_g6:

        cjne    a,#7,rxsy_badpkt

; 襫 䫠

        mov     a,bits          ; ਬ, 楫  ᫮  ਭ
        cjne    a,#7,rxsy_badpkt ; ஡ - 訡

        mov     a,wr_rx_count+1 ; ਬ, ᪮쪮 ਭ 
        jnz     rxsy_goodlen
        clr     c
        mov     a,wr_rx_count
        subb    a,#14
        jnc     rxsy_goodlen

        jmp     rxsy_badpkt      ; ᫨  - 訡

rxsy_goodlen:

        mov     a,rx_crcm2      ; 塞 CRC ਭ⮣ 
        xrl     a,#0FFh
        xrl     rnd,a           ; ନ㥬 砩 ᫮
        cjne    a,capm2,rxsy_badpkt

        mov     a,rx_crcm2+1
        xrl     a,#0FFh
        cjne    a,capm1,rxsy_badpkt

        call    flush_rx_buf    ; 訡  - 뢠 ਥ 
        call    reset_rx_buf    ; 뢠 ਥ 
        jmp     rxsy_rxdone

rxsy_badpkt:
                ; 訡 ਥ 

        call    reset_rx_buf    ; 뢠 ਥ 

        jmp     rxsy_rxdone

rxsy_rxwrite:


;jmp rxsy_rxdone
        mov     a,r0    ; ६ ਭ 
        rrc     a       ; ⨬ ࠢ, 頥 訩   C
        mov     r0,a    ; 

        mov     a,cap   ; ६ ନ㥬 
        rrc     a       ; ⨬ ࠢ  ᨬ  訩  ਭ
        mov     cap,a   ; 

        djnz    bits,rxsy_mnextbit       ; ନ஢ 8 ?

        ; , 襬  ਥ 

        mov     a,wr_rx_count   ; 稢  ᠭ 
        add     a,#1
        mov     wr_rx_count,a
        mov     a,#0
        addc    a,wr_rx_count+1
        mov     wr_rx_count+1,a

        mov     capm2,capm1     ; ࠭塞 2 । 
        mov     capm1,cap

        mov     b,cap   ; ६ ਭ 
        call    wr_rx_buf       ; 襬   ਥ

        mov     rx_crcm2,rx_crcm1       ; ࠭塞 2 । CRC
        mov     rx_crcm2+1,rx_crcm1+1

        mov     rx_crcm1,rx_crc
        mov     rx_crcm1+1,rx_crc+1

        mov     a,cap           ; ⠥ CRC
        call    update_rx_crc

        mov     bits,#8         ;   ନ஢ 8 

rxsy_mnextbit:
        djnz    r1,rxsy_rxwrite  ; ᫨   ਭ  ᠭ - 塞


rxsy_rxdone:
        pop     dpl
        pop     dph
        pop     1       ; pop r1
        pop     0       ; pop r0
        pop     b

rxsy_exit:

;;        clr     ie1     ; 뢠 䫠   뢠

        pop     acc
        pop     psw

        reti

;endif

;-------------------------------------------------------------------------

if 0=1

; NEW!

; ஭ ਥ FX469 - 뢠 INT1

int_rxsy:

        push    psw
        push    acc

        mov     c,NRZI  ; 室 ᨣ

        mov     a,rb_buf  ;   8 
        rrc     a
        mov     rb_buf,a

        inc     rb_cntr ; 稪

mov a,rb_cntr
anl a,#8
jz rxsy_exit
cpl DCD

rxsy_exit:
        pop     acc
        pop     psw

        reti

;-------------------------------------------------------------------------

; ࠡ⪠    , ਭ  FX469

rb_all:

;setb DCD
        clr     EA
        mov     rb_buf_old,rb_buf        ;  ਭ 
        mov     a,rb_cntr       ; 稪
        mov     rb_cntr,#0
        setb    EA

        jz      rba_exit
        anl     a,#7
        mov     rb_cntr_old,a

;  

        mov     r1,a
        mov     a,rb_buf_old
rba_n:
        cjne    r1,#8,rba_sh
        jmp     rba_pr
rba_sh:
        rr      a
        inc     r1
        jmp     rba_n

; ࠡ⪠ ⠢ 

rba_pr:
        mov     rb_buf_old,a

rba_nextbit:
        mov     a,rb_cntr_old
        jz      rba_exit

        dec     rb_cntr_old
        mov     a,rb_buf_old
        rrc     a
        mov     rb_buf_old,a

        call    receive_bit     ; ࠡ뢠  

rba_exit:

;clr DCD
        ret

;-------------------------------------------------------------------------

; ਥ ।   FX469

receive_bit:

; ࠥ  PSK

        mov     a,is_psk
        jz      rb_npsk

        jb      NRZI,rb_changed       ; '1' (. ⮭) - ஢ 
        jmp     rb_notchanged         ; '0' (. ⮭) -  

rb_npsk:
        mov     a,rxsy_lastbit
        jb      NRZI,rb_1     ; 室 ᨣ

        ; ਭ  = 0

        jz      rb_notchanged
        jmp     rb_changed

rb_1:
        ; ਭ  = 1
        jnz     rb_notchanged
        jmp     rb_changed

; ਭ  ⠪ ,  ।騩

rb_notchanged:
        inc     rxsy_cntr       ;  ...
        jmp     rb_exit

; 室 ஢  - ࠡ뢠

rb_changed:

        mov     a,rxsy_cntr     ; 稪 
        mov     rxsy_cntr,#1

;  ᨬ  ⢠   뢠   ᪮쪮 

        cjne    a,#1,rb_g1
        mov     r0,#0
        mov     r1,#1
        jmp     rb_rxwrite     ; ਭ : 0 (0.5<t<1.5)

rb_g1:
        cjne    a,#2,rb_g2
        mov     r0,#01b
        mov     r1,#2
        jmp     rb_rxwrite     ; ਭ : 01 (1.5<t<2.5)

rb_g2:
        cjne    a,#3,rb_g3
        mov     r0,#011b
        mov     r1,#3
        jmp     rb_rxwrite     ; ਭ : 011 (2.5<t<3.5)

rb_g3:
        cjne    a,#4,rb_g4
        mov     r0,#0111b
        mov     r1,#4
        jmp     rb_rxwrite     ; ਭ : 0111 (3.5<t<4.5)

rb_g4:
        cjne    a,#5,rb_g5
        mov     r0,#01111b
        mov     r1,#5
        jmp     rb_rxwrite     ; ਭ : 01111 (4.5<t<5.5)

rb_g5:
        cjne    a,#6,rb_g6
        mov     r0,#11111b
        mov     r1,#5
        jmp     rb_rxwrite     ; ਭ : 11111 (5.5<t<6.5), -䨭

rb_g6:

        cjne    a,#7,rb_badpkt


; 襫 䫠

        mov     a,bits          ; ਬ, 楫  ᫮  ਭ
        cjne    a,#7,rb_badpkt ; ஡ - 訡

        mov     a,wr_rx_count+1 ; ਬ, ᪮쪮 ਭ 
        jnz     rb_goodlen
        clr     c
        mov     a,wr_rx_count
        subb    a,#14
        jnc     rb_goodlen

        jmp     rb_badpkt      ; ᫨  - 訡

rb_goodlen:

        mov     a,rx_crcm2      ; 塞 CRC ਭ⮣ 
        xrl     a,#0FFh
        xrl     rnd,a           ; ନ㥬 砩 ᫮
        cjne    a,capm2,rb_badpkt

        mov     a,rx_crcm2+1
        xrl     a,#0FFh
        cjne    a,capm1,rb_badpkt

        call    flush_rx_buf    ; 訡  - 뢠 ਥ 
        call    reset_rx_buf    ; 뢠 ਥ 
        jmp     rb_exit

rb_badpkt:
                ; 訡 ਥ 

        call    reset_rx_buf    ; 뢠 ਥ 

        jmp     rb_exit

rb_rxwrite:

        mov     a,r0    ; ६ ਭ 
        rrc     a       ; ⨬ ࠢ, 頥 訩   C
        mov     r0,a    ; 

        mov     a,cap   ; ६ ନ㥬 
        rrc     a       ; ⨬ ࠢ  ᨬ  訩  ਭ
        mov     cap,a   ; 

        djnz    bits,rb_mnextbit       ; ନ஢ 8 ?

        ; , 襬  ਥ 

        mov     a,wr_rx_count   ; 稢  ᠭ 
        add     a,#1
        mov     wr_rx_count,a
        mov     a,#0
        addc    a,wr_rx_count+1
        mov     wr_rx_count+1,a

        mov     capm2,capm1     ; ࠭塞 2 । 
        mov     capm1,cap

        mov     b,cap   ; ६ ਭ 
        call    wr_rx_buf       ; 襬   ਥ

        mov     rx_crcm2,rx_crcm1       ; ࠭塞 2 । CRC
        mov     rx_crcm2+1,rx_crcm1+1

        mov     rx_crcm1,rx_crc
        mov     rx_crcm1+1,rx_crc+1

        mov     a,cap           ; ⠥ CRC
        call    update_rx_crc

        mov     bits,#8         ;   ନ஢ 8 

rb_mnextbit:
        djnz    r1,rb_rxwrite  ; ᫨   ਭ  ᠭ - 塞


rb_exit:
        ret

endif

;-------------------------------------------------------------------------

; ஭ ।稪 FX469 - 뢠 INT0

int_txsy:

        push    psw
        push    acc

        mov     a,mode          ;  ࠡ ஫
        cjne    a,#M_RX,txsy_norx
        jmp     txsy_exit

txsy_norx:

;  ࠡ -  ਥ


; ࠥ  ० PSK

        mov     a,is_psk
        jz      txsy_not_psk

        mov     a,rxsy_lastbit
        jz      txsy_not_psk

        clr     NRZO            ; '0' - ᮪ ⮭
        clr     rxsy_lastbit

txsy_not_psk:

; ⠭⭠ । ⮢

        mov     a,to_count      ; ⠫ ?
        dec     a
        jz      txsy_cdone        ; , 室  ᫥騬

        mov     to_count,a      ; H, ⠥ 

        jmp     txsy_exit         ; H ⮬ 稢

txsy_cdone:

; 쭥訩 

        cpl     NRZO            ; 塞 室 ᨣ
                                ;  PSK -  '1' ( ⮭)
        mov     rxsy_lastbit,#1

        push    b
        push    dpl
        push    dph

        mov     to_count,#1     ;  㬮砭 - ନ㥬 1 ਮ প

txsy_txnext:

        mov     a,bits  ; 쪮    ⠫ ।
        jz      txsy_txnb

        jmp     txsy_txpb ; ᫨  ⠫ - த

txsy_txnb:
        mov     bits,#8 ; H ⠫ -    ।
        mov     cap,#FLAG       ;  㬮砭 - । 䫠
        mov     true_flag,#FLAG_YES     ; । 䫠 - -䨭 

txsy_rdnext:
        mov     a,mode  ;  ࠡ
        cjne    a,#M_TX,txsy_ntx

;  - ।   

        call    rd_tx_buf       ; ⠥ ᫥騩   
        jc      txsy_txno       ; ᫨  - । 䫠  蠥
        mov     cap,b

        mov     a,tx_state      ; ﭨ । 
        cjne    a,#TX_NONE,txsy_txnormal
                        ;    ,  -   

        mov     rd_tx_count,b   ; ਬ  
        call    rd_tx_buf
        jc      txsy_txno
        mov     rd_tx_count+1,b

        mov     tx_state,#TX_NORMAL     ;  ।  

        mov     cap,#FLAG       ; H砫  - । 䫠
        jmp     txsy_txs

txsy_txnormal:
        mov     a,rd_tx_count   ; ⠥ 1  稪 
        clr     c
        subb    a,#1
        mov     rd_tx_count,a
        mov     b,a
        mov     a,rd_tx_count+1
        subb    a,#0
        mov     rd_tx_count+1,a

        mov     true_flag,#FLAG_NO      ; ।  䫠 - 䨭 ࠧ襭

        jnz     txsy_txs  ; ஢塞 ⮪: 0 -  
        mov     a,b
        jnz     txsy_txs

        mov     tx_state,#TX_NONE       ;  稫

        jmp     txsy_txs  ; H ᫥   ।

txsy_txno:

        mov     mode,#M_TXT     ; H稭 txtail
        jmp     txsy_txs

txsy_ntx:

        cjne    a,#M_TXD,txsy_ntxd

;  - ନ஢ txdelay

        mov     a,txdelay_count ; ⠥  稪  8 
        clr     c
        subb    a,#8
        mov     txdelay_count,a
        mov     a,txdelay_count+1
        subb    a,#0
        mov     txdelay_count+1,a

        jnc     txsy_txs  ; ᫨ txdelay  祭 - ⠥ 

        mov     mode,#M_TX      ;  ४砥  ० ।
        mov     tx_state,#TX_NONE       ;  ।  砫

        jmp     txsy_txs

txsy_ntxd:

;  ࠡ - ନ஢ txtail

        mov     a,txtail_count  ; ⠥  稪  8 
        clr     c
        subb    a,#8
        mov     txtail_count,a
        mov     a,txtail_count+1
        subb    a,#0
        mov     txtail_count+1,a

        jnc     txsy_txs  ; ᫨ txtail  祭 - ⠥ 

        clr     EA
        clr     TR0

        mov     mode,#M_RX      ;  ४砥  ० ਥ

        setb    PTT     ; ࠭ᨢ -  ਥ

        mov     bits,#8         ; H    ਭ

        setb    TR0
        setb    EA
        jmp     txsy_txend


txsy_txs:
txsy_txpb:
        dec     bits    ; ਬ ⠫ 
        mov     a,cap
        rrc     a
        mov     cap,a

        jc      txsy_tx1  ;  ?
        jmp     txsy_txend ; H㫥, 뢠

txsy_tx1:

        mov     a,to_count      ;  -  প    
        inc     a
        mov     to_count,a
        cjne    a,#BS+1,txsy_txjbs  ; ᫨  -䨭, ⠥ ᫥騩 

        mov     a,true_flag     ; ⢨⥫쭮   ⨬ । 䫠?

        cjne    a,#FLAG_YES,txsy_txend ; ᫨  䫠,  ⢨⥫쭮 ⠢塞 0

        jmp     txsy_txnext       ; : -䨭  

txsy_txend:
        pop     dph
        pop     dpl
        pop     b

txsy_exit:

        pop     acc
        pop     psw

        reti

txsy_txjbs:
        jmp     txsy_txnext


;-------------------------------------------------------------------------

; ࠡ稪 뢠  ᫥⥫쭮 

int_art:
        push    psw

        jnb     RI,art_norx

        call    a_rx            ; ࠡ뢠 砩 ਥ 
        clr     RI

art_norx:
        jnb     TI,art_notx

        call    a_tx            ; ᫨ , । 
        clr     TI

art_notx:
        pop     psw
        reti

;-------------------------------------------------------------------------

; ࠡ稪 襤襣   
;  ᨬ  襤襣   ﭨ ਥ 
;   tx_buf

a_rx:
        push    acc
        push    b
        push    dph
        push    dpl

        mov     a,sbuf          ; ⠥ 襤訩 ᨬ
        mov     b,a

        mov     a,in_state      ; ਬ ﭨ ਥ
        cjne    a,#IS_FESC,in_nfesc

                ;  ᨬ - FESC
        mov     a,b     ; ਭ ᥩ ᨬ

        cjne    a,#TFEND,in_escnfend
        mov     b,#FEND         ; 塞 FESC TFEND  FEND
        jmp     in_wrbuf

in_escnfend:
        cjne    a,#TFESC,in_escnfesc
        mov     b,#FESC         ; 塞 FESC TFESC  FESC
        jmp     in_wrbuf

in_escnfesc:
        jmp     in_reset  ; 訡  ᫥⥫쭮 - 뢠 

in_nfesc:
                ;  ᨬ - ଠ
        mov     a,b     ; ਬ  ਭ ᨬ
        cjne    a,#FESC,in_isnfesc

        mov     in_state,#IS_FESC       ; ਭ ᨬ - FESC
        jmp     in_exit ;     襬 - ய᪠

in_isnfesc:
        cjne    a,#FEND,in_wrbuf        ; ᫨ 襫  FEND - 襬  

                ; 襫 FEND

        mov     a,in_type       ;  
        anl     a,#0Fh  ;   ࠤ
        cjne    a,#0,in_pktparam  ; ᫨   ࠬ, ⠢塞 

                ; . 襫 FEND, 騩  

        mov     a,wr_tx_count   ; ᫨  㫥  - 뢠 
        jnz     in_pktnz
        mov     a,wr_tx_count+1
        jnz     in_pktnz
        jmp     in_reset

in_pktnz:
        mov     a,wr_tx_count   ; ᫨   -1 - 뢠 
        cjne    a,#255,in_pktgood
        mov     a,wr_tx_count+1
        inc     a
        jz      in_reset

in_pktgood:
        mov     a,tx_crc        ; 襬 ஫ 㬬 
        xrl     a,#0FFh
        mov     b,a
        call    wr_tx_buf
        mov     a,tx_crc+1
        xrl     a,#0FFh
        mov     b,a
        call    wr_tx_buf

        call    flush_tx_buf    ; 뢠  ਥ
        jmp     in_reset        ; 뢠  - 㦥 ᫥騩

in_pktparam:
;        mov     a,wr_tx_count   ; ᫨    1 - 訡
;        cjne    a,#1,in_reset
        mov     a,wr_tx_count+1 ; ᫨   255 - 訡
        jnz     in_reset

                ; ⠢塞 ࠬ

        mov     a,in_type       ;   -  ࠬ ⠢
        anl     a,#0Fh  ;   ࠤ

        cjne    a,#PARAM_TXDELAY,sp_notxdelay
        mov     txdelay,in_value
        jmp     in_reset        ;  ᠬ   㦥 - 뢠 

sp_notxdelay:
        cjne    a,#PARAM_PERSIST,sp_nopersist
        mov     persist,in_value
        jmp     in_reset        ;  ᠬ   㦥 - 뢠 

sp_nopersist:
        cjne    a,#PARAM_SLOTTIME,sp_noslottime
        mov     slottime,in_value
        jmp     in_reset        ;  ᠬ   㦥 - 뢠 

sp_noslottime:
        cjne    a,#PARAM_TXTAIL,sp_notxtail
        mov     txtail,in_value
        jmp     in_reset        ;  ᠬ   㦥 - 뢠 

sp_notxtail:
        cjne    a,#PARAM_RETURN,in_reset ; ⠫ ࠬ  ন
        jmp     wd_reset        ;  १ watchdog

in_wrbuf:

        mov     in_state,#IS_NORMAL     ;   ଠ ᨬ

        mov     a,wr_tx_count   ; 稢  稪 
        add     a,#1
        mov     wr_tx_count,a
        mov     a,wr_tx_count+1
        addc    a,#0
        mov     wr_tx_count+1,a

        mov     a,wr_tx_count+1 ; ஢塞 砨 㫥  ࢮ 
        jnz     in_wtxb
        mov     a,wr_tx_count
        jnz     in_not0
        mov     in_type,b       ; H㫥  - ⨯ KISS-
        jmp     in_exit         ;     襬

in_not0:
        cjne    a,#1,in_wtxb
        mov     in_value,b  ;   - 祭 ࠬ KISS-
                            ;     砫 ⮬ ,
                            ; ⮬   

in_wtxb:
        mov     a,b
        call    update_tx_crc   ; ⠥ ஫ 㬬
        call    wr_tx_buf       ; 襬    ।
        jmp     in_exit

in_reset:
        call    reset_tx_buf    ; 뢠  ।
        mov     in_state,#IS_NORMAL     ;   ଠ ᨬ

in_exit:
        pop     dpl
        pop     dph
        pop     b
        pop     acc

        ret

;-------------------------------------------------------------------------

; ।   

; ⠥   rx_buf,  ᫨ , ।     KISS-ଠ

a_tx:
        push    acc
        push    b
        push    dph
        push    dpl

;cpl DCD
        jnb     RTS,out_hostfree
        jmp     out_makefree ;     - । 

out_hostfree:
        mov     a,out_state     ; - 㦥 ।  ?
        cjne    a,#OS_NONE,out_se       ; , த

        call    rd_rx_buf       ; ⠥    
        jc      out_makefree    ;  祣 - ᠥ
        mov     rd_rx_count,b   ; 稪 
        call    rd_rx_buf       ; ⠥   ன 
;        jc      out_makefree    ;  祣 - ᠥ
;bug1:
;clr EA
;cpl DCDOUT
;jc bug1
;setb EA
        mov     rd_rx_count+1,b

        mov     a,#FEND         ; । FEND - 砫 KISS-

        mov     out_state,#OS_1FEND     ; ਬ,  । 1- FEND

        jmp     out_sbuf

out_se:
        cjne    a,#OS_1FEND,out_n1fend ;  ࠧ । FEND?

        mov     a,#PARAM_DATA   ; ன  - ⨯ KISS- - 

        mov     out_state,#OS_NORMAL    ;  ࠡ⠥  묨 ⠬

        jmp     out_sbuf

out_n1fend:
        cjne    a,#OS_TFESC,out_ntfesc ;  ࠧ । FESC  FESC ?

        mov     a,#TFESC        ; 뫠  FESC  FESC TFESC

        mov     out_state,#OS_NORMAL    ;  ࠡ⠥  묨 ⠬

        jmp     out_sbuf

out_ntfesc:

        cjne    a,#OS_TFEND,out_ntfend ;  ࠧ । FESC  FEND ?

        mov     a,#TFEND        ; 뫠  FEND  FESC TFEND

        mov     out_state,#OS_NORMAL    ;  ࠡ⠥  묨 ⠬

        jmp     out_sbuf

out_ntfend:

        mov     a,rd_rx_count+1 ; ᫨  竨   - த
        jnz     out_nend
        mov     a,rd_rx_count

;       cjne    smack,#SMACK_OFF,out_smack ;  ᨬ  ०

        cjne    a,#2,out_nend   ;  ⮬   CRC

        call    rd_rx_buf       ; ய᪠ CRC
;/        jc      out_pktcrash    ;   
;jc bug1
        call    rd_rx_buf
;/        jc      out_pktcrash    ;   
;jc bug1

        mov     a,#FEND

        mov     out_state,#OS_NONE      ;  KISS- ।

        jmp     out_sbuf

;out_smack:

out_nend:
        mov     a,rd_rx_count   ; 蠥 ⢮ । 
        clr     c
        subb    a,#1
        mov     rd_rx_count,a
        mov     a,rd_rx_count+1
        subb    a,#0
        mov     rd_rx_count+1,a

        call    rd_rx_buf       ; ⠥   
;/        jc      out_pktcrash    ;   
;jc bug1
        mov     a,b
        cjne    a,#FEND,out_nwfend

        mov     a,#FESC         ; 塞 FEND  FESC TFEND
        mov     out_state,#OS_TFEND
        jmp     out_sbuf

out_nwfend:
        cjne    a,#FESC,out_sbuf

        mov     a,#FESC         ; 塞 FESC  FESC TFESC
        mov     out_state,#OS_TFESC
        jmp     out_sbuf

;/out_pktcrash:
;/        mov     out_state,#OS_NONE      ;  KISS- ।

out_makefree:
        mov     out_order,#OUT_FREE ; 뢠  㤥,     ।
        jmp     out_exit

out_sbuf:
        mov     out_order,#OUT_BUSY ; 뢠 ,   । 
        mov     sbuf,a

out_exit:

; call    check_stack    ; ஢塞 ⥪  楫⭮

        pop     dpl
        pop     dph
        pop     b
        pop     acc

        ret

;-------------------------------------------------------------------------

;  㪠⥫  ਥ 
; 㪠⥫ -  DPTR

; ᫨ 㪠⥫ ⨣  ,  ॡ뢠  砫

next_rxptr:
        inc     dptr    ; 稢 㪠⥫
        mov     a,dpl
        xrl     rnd,a           ; ନ㥬 砩 ᫮
        cjne    a,#low(rx_buf_end),noteqrxptr   ; ⥫ ⨣ ?
        mov     a,dph
        cjne    a,#high(rx_buf_end),noteqrxptr
        mov     dptr,#rx_buf    ; ᫨ 㪠⥫ ⨣  -  砫 
noteqrxptr:
        ret

;-------------------------------------------------------------------------

;  㪠⥫  ।饬 
; 㪠⥫ -  DPTR

; ᫨ 㪠⥫ ⨣  ,  ॡ뢠  砫

next_txptr:
        inc     dptr    ; 稢 㪠⥫
        mov     a,dpl
        xrl     rnd,a           ; ନ㥬 砩 ᫮
        cjne    a,#low(tx_buf_end),noteqtxptr   ; ⥫ ⨣ ?
        mov     a,dph
        cjne    a,#high(tx_buf_end),noteqtxptr
        mov     dptr,#tx_buf    ; ᫨ 㪠⥫ ⨣  -  砫 
noteqtxptr:
        ret

;-------------------------------------------------------------------------

; ⨥ ।饣 

flush_tx_buf:

        mov     a,order_txbuf   ; H   ?
        jnz     reset_tx_buf    ;  - ࠧ 뢠

        mov     dpl,tx_addrlen  ; 襬    + 2 (CRC)
        mov     dph,tx_addrlen+1
        mov     a,wr_tx_count
        add     a,#2
        push    psw
        movx    @dptr,a
        call    next_txptr
        mov     a,wr_tx_count+1
        pop     psw
        addc    a,#0
        movx    @dptr,a

        clr     EA              ; 뢠 
        mov     tx_head,tx_pro_head
        mov     tx_head+1,tx_pro_head+1
        setb    EA

        mov     any,#ANY_YES    ; -   ।

ftxb_exit:
        ret
;-------------------------------------------------------------------------

; ⨥ ਥ 

flush_rx_buf:

        mov     a,order_rxbuf   ; H   ?
        jnz     reset_rx_buf    ;  - ࠧ 뢠

        mov     dpl,rx_addrlen  ; 襬   
        mov     dph,rx_addrlen+1
        mov     a,wr_rx_count
        movx    @dptr,a
        call    next_rxptr
        mov     a,wr_rx_count+1
        movx    @dptr,a

        clr     EA              ; 뢠 
        mov     rx_head,rx_pro_head
        mov     rx_head+1,rx_pro_head+1
        setb    EA

        ret

;-------------------------------------------------------------------------

;  ।饣 

reset_tx_buf:

        mov     order_txbuf,#BUF_FREE   ; 砫 ⠥,   

        clr     EA
        mov     tx_pro_head,tx_head
        mov     tx_pro_head+1,tx_head+1
        setb    EA

        mov     wr_tx_count,#255        ;   祣  ᠫ,
        mov     wr_tx_count+1,#255      ;  1 ᨬ ய⨬

        mov     tx_addrlen,tx_head      ;  ᯮ  砫
        mov     tx_addrlen+1,tx_head+1

        mov     tx_crc,#0FFh            ; H稭  CRC 
        mov     tx_crc+1,#0FFh

        mov     b,#66
        call    wr_tx_buf       ; ⠢塞    - 2 
        mov     b,#66
        call    wr_tx_buf

        ret

;-------------------------------------------------------------------------

;  ਥ 

reset_rx_buf:

        mov     order_rxbuf,#BUF_FREE   ; 砫 ⠥,   

        clr     EA
        mov     rx_pro_head,rx_head
        mov     rx_pro_head+1,rx_head+1
        setb    EA

        mov     wr_rx_count,#0          ;   祣  ᠫ
        mov     wr_rx_count+1,#0

        clr     EA
        mov     rx_addrlen,rx_head      ;  ᯮ  砫
        mov     rx_addrlen+1,rx_head+1
        setb    EA

        mov     rx_crc,#0FFh            ; H稭  CRC 
        mov     rx_crc+1,#0FFh

        mov     b,#intro_end-intro      ; ⠢塞    - 2 
        call    wr_rx_buf
        mov     b,#0
        call    wr_rx_buf

        mov     bits,#8         ;   ਭ

        ret

;-------------------------------------------------------------------------

;    ।騩 

; 室:  -  b

wr_tx_buf:

        mov     a,order_txbuf   ;    ।
        jnz     wr_tx_exit      ; ᫨ ,  襬

        clr     EA
        mov     dpl,tx_pro_head ;  DPTR -  ०饩 
        mov     dph,tx_pro_head+1
        setb    EA

        mov     a,b
        movx    @dptr,a         ; 襬   
        xrl     rnd,a           ; ନ㥬 砩 ᫮

        call    next_txptr      ;  㪠⥫

        mov     a,dpl
        xrl     rnd,a           ; ନ㥬 砩 ᫮
        clr     EA
        cjne    a,tx_tail,wr_tx_ok      ; ࠢ 㪠⥫  墮⮬
        mov     a,dph
        cjne    a,tx_tail+1,wr_tx_ok
        setb    EA

        setb    CTS ; ᫨  , 頥  뫠 
        mov     order_txbuf,#BUF_FULL   ; ,   
        jmp     wr_tx_exit

wr_tx_ok:

        clr     c               ; 쪮  ⠫  ?
        mov     a,tx_tail
        subb    a,dpl
        mov     a,tx_tail+1
        subb    a,dph
        setb    EA

        anl     a,#high(BUF_SIZE)-1 ; ᪠  砩 ⥫쭮 祭
        jnz     wr_store

        setb    CTS ; ᫨  , 頥  뫠 

wr_store:
        clr     EA
        mov     tx_pro_head,dpl ;  㪠⥫  ० 
        mov     tx_pro_head+1,dph
        setb    EA

wr_tx_exit:
        ret

;-------------------------------------------------------------------------

;    ਥ 

; 室:  -  b

;;;; 室: c=1, ᫨ ந諮 ९
;;;; ९ ந室, ᫨ rx_pro_head ⨣ rx_tail

wr_rx_buf:

        mov     a,order_rxbuf   ;    ਥ
        jnz     wr_rx_exit      ; ᫨ ,  襬

        clr     EA
        mov     dpl,rx_pro_head ;  DPTR -  ०饩 
        mov     dph,rx_pro_head+1
        setb    EA

        mov     a,b
        movx    @dptr,a         ; 襬   
        xrl     rnd,a           ; ନ㥬 砩 ᫮

        call    next_rxptr      ;  㪠⥫

        mov     a,dpl
        clr     EA
        cjne    a,rx_tail,wr_rx_ok      ; ࠢ 㪠⥫  墮⮬
        mov     a,dph
        cjne    a,rx_tail+1,wr_rx_ok

        setb    EA
        mov     order_rxbuf,#BUF_FULL   ; ,   
        jmp     wr_rx_exit

wr_rx_ok:
        mov     rx_pro_head,dpl ;  㪠⥫  ० 
        mov     rx_pro_head+1,dph
        setb    EA

wr_rx_exit:
        ret

;-------------------------------------------------------------------------

; ⥭   ।饣 

; 室:  -  b, c=1, ᫨  祣
;  祣, ᫨ tx_tail ⨣ tx_head

rd_tx_buf:

        clr     EA
        mov     dpl,tx_tail     ;  DPTR -  墮
        mov     dph,tx_tail+1

        mov     a,dpl
        xrl     rnd,a           ; ନ㥬 砩 ᫮
        cjne    a,tx_head,rd_tx_ok      ; ࠢ 㪠⥫  
        mov     a,dph
        cjne    a,tx_head+1,rd_tx_ok

        mov     any,#ANY_NO     ; ,  । 祣

        setb    EA
        clr     CTS     ; 蠥  뫠 

        setb    c       ; ᫨ ࠢ -  祣, c=1
        ret

rd_tx_ok:
        setb    EA
        movx    a,@dptr         ; ⠥   
        mov     b,a

        call    next_txptr      ;  㪠⥫

        mov     tx_tail,dpl     ;  㪠⥫  墮
        mov     tx_tail+1,dph

        clr     c               ; 쪮  ⠫  ?
        mov     a,dpl
        clr     EA
        subb    a,tx_head
        mov     a,dph
        subb    a,tx_head+1
        setb    EA

        anl     a,#high(BUF_SIZE)-1 ; ᪠  砩 ⥫쭮 祭
        jz      rd_tx_exit      ;    ᢮ ?

        clr     CTS     ; , ࠧ蠥  뫠 

rd_tx_exit:
        clr     c       ;  , c=0
        ret

;-------------------------------------------------------------------------

; ⥭   ਥ 

; 室:  -  b, c=1, ᫨  祣
;  祣, ᫨ rx_tail ⨣ rx_head

rd_rx_buf:

        clr     EA
        mov     dpl,rx_tail     ;  DPTR -  墮
        mov     dph,rx_tail+1

        mov     a,dpl
        cjne    a,rx_head,rd_rx_ok      ; ࠢ 㪠⥫  
        mov     a,dph
        cjne    a,rx_head+1,rd_rx_ok

        setb    EA
        setb    c       ; ᫨ ࠢ -  祣, c=1
        ret

rd_rx_ok:
        setb    EA
        movx    a,@dptr         ; ⠥   
        mov     b,a

        call    next_rxptr      ;  㪠⥫

        clr     EA
        mov     rx_tail,dpl     ;  㪠⥫  墮
        mov     rx_tail+1,dph
        setb    EA
        clr     c       ;  , c=0
        ret

;-------------------------------------------------------------------------

;  ஫쭮 㬬 । 

; 室: a - 

update_tx_crc:

        push    dph
        push    dpl

        mov     dptr,#crc_tab
        xrl     a,tx_crc

        push    acc
        add     a,dpl   ; 砥  dptr  ᫮  ⠡
        mov     dpl,a
        mov     a,dph
        addc    a,#0
        mov     dph,a
        pop     acc
        add     a,dpl
        mov     dpl,a
        mov     a,dph
        addc    a,#0
        mov     dph,a

        mov     a,#1            ; ६ 訩  - ࠭ 
        movc    a,@a+dptr
        xrl     a,tx_crc+1
        mov     tx_crc,a        ; 砥 訩  㬬

        mov     a,#0            ; ६ 訩  - ࠭ 
        movc    a,@a+dptr
        mov     tx_crc+1,a      ; 砥 訩  㬬

        pop     dpl
        pop     dph

        ret

;-------------------------------------------------------------------------

;  ஫쭮 㬬 ਭ 

; 室: a - 

update_rx_crc:

        push    dph
        push    dpl

        mov     dptr,#crc_tab
        xrl     a,rx_crc

        push    acc
        add     a,dpl   ; 砥  dptr  ᫮  ⠡
        mov     dpl,a
        mov     a,dph
        addc    a,#0
        mov     dph,a
        pop     acc
        add     a,dpl
        mov     dpl,a
        mov     a,dph
        addc    a,#0
        mov     dph,a

        mov     a,#1            ; ६ 訩  - ࠭ 
        movc    a,@a+dptr
        xrl     a,rx_crc+1
        mov     rx_crc,a        ; 砥 訩  㬬

        mov     a,#0            ; ६ 訩  - ࠭ 
        movc    a,@a+dptr
        mov     rx_crc+1,a      ; 砥 訩  㬬

        pop     dpl
        pop     dph

        ret

;-------------------------------------------------------------------------

; H砫 ⠭

init:

;  ⮢

        clr    CTS      ; CTS ⨢
        clr    DCD      ; DCD  ⨢

; 樠 ⠩஢

        mov     tmod,#00100001b ;  ࠡ ⠩஢
                                ;  0 - ० 1
                                ;  1 - ० 2

        mov     th1,#T1_CONST    ; 㦠 ⠭  ⠩ 1

        setb    tcon.4  ;  ⠩ 0
        setb    tcon.6  ;  ⠩ 1

; 樠 ᫥⥫쭮 

        mov     scon,#01011000b ;  ० ᫥⥫쭮 
        mov     87h,#10000000b  ; ࠢ ॣ஬ 魮

        clr     TI      ; 뢠 䫠 ਥ  ।稪
        clr     RI

;  뢠

        setb    tcon.0  ; 뢠 INT0 -  १
        setb    tcon.2  ; 뢠 INT1 -  १
        setb    ie.0    ; 蠥 뢠 INT0
        setb    ie.2    ; 蠥 뢠 INT1

        setb    ie.4    ; 襭 뢠  ᫥. 

        setb    ie.1    ; 蠥 뢠  ⠩ 0 - 
                        ;  ७ ६
        clr     ie.3    ; 頥 뢠  ⠩ 1 - 
                        ;  ᫥⥫쭮 

        clr     ie0     ; 뢠 䫠 INT0, INT1
        clr     ie1

        mov     a,#0    ;  ᨬ  ⪨ rs-232
        mov     sbuf,a

        mov     dptr,#10000
init_s232:
        cpl     NRZO
        djnz    dpl,init_s232
        djnz    dph,init_s232

        mov     ip,#5   ; ᮪ ਮ 뢠 INT0, INT1
;        mov     ip,#16   ; ᮪ ਮ 뢠  . 

; ⥫

        mov     a,#low(tx_buf)  ; ⥫ ।饣 
        mov     tx_pro_head,a
        mov     tx_head,a
        mov     tx_tail,a

        mov     a,#high(tx_buf)
        mov     tx_pro_head+1,a
        mov     tx_head+1,a
        mov     tx_tail+1,a

        mov     a,#low(rx_buf)  ; ⥫ ਥ 
        mov     rx_pro_head,a
        mov     rx_head,a
        mov     rx_tail,a

        mov     a,#high(rx_buf)
        mov     rx_pro_head+1,a
        mov     rx_head+1,a
        mov     rx_tail+1,a

        call    reset_tx_buf    ;   ।
        call    reset_rx_buf    ;   ਥ

; ६

        mov     mode,#M_RX      ;  ࠡ - ਥ

        mov     bits,#8         ; H    ਭ

        mov     out_order,#OUT_FREE
        mov     out_state,#OS_NONE

        mov     in_state,#IS_NORMAL

        mov     rxsy_lastbit,#0

        mov     any,#ANY_NO
        mov     slottime_count,#0

        mov     order_txbuf,#BUF_FREE
        mov     order_rxbuf,#BUF_FREE

        mov     rnd,#100

        mov     stk_check,#0FFh
        mov     stk_check+1,#0FFh

        mov     u_tick,#low(U_TICK)  ; ⢮ ⨪ ⠩  10 
        mov     u_tick+1,#high(U_TICK)

        mov     rb_cntr,#0 ; 稪


; ࠬ

        mov     txdelay,#20
        mov     persist,#63
        mov     slottime,#1
        mov     txtail,#5

;    ਥ ,  㤥 ।  

        mov     dptr,#intro
        mov     r3,#intro_end-intro
i_next:
        mov     a,#0
        movc    a,@a+dptr       ; ६ 

        push    dph
        push    dpl

        mov     dpl,rx_pro_head
        mov     dph,rx_pro_head+1
        movx    @dptr,a
        inc     dptr
        mov     rx_pro_head,dpl
        mov     rx_pro_head+1,dph

        pop     dpl
        pop     dph

        inc     dptr
        djnz    r3,i_next       ; 室  ᫥饬

        mov     rx_head,rx_pro_head     ; 뢠 
        mov     rx_head+1,rx_pro_head+1


; 襬 ᪮ ࠡ

        mov     dptr,#rx_buf+(intro_speed-intro)+2

        mov     a,p3
        anl     a,#00110000b
        cjne    a,#00110000b,i_notbad
        jmp     init_exit       ; 00 - ୮  ஢
i_notbad:

        cjne    a,#00010000b,i_n1200    ; 1200 
        mov     a,#'1'
        movx    @dptr,a
        inc     dptr
        mov     a,#'2'
        movx    @dptr,a

        mov     bpu,#BPU1200    ; ᫮   10 
        mov     is_psk,#0       ; PSK 몫

        jmp     i_zeroes

i_n1200:

        jnz     i_n2400    ; 2400 
        mov     a,#'2'
        movx    @dptr,a
        inc     dptr
        mov     a,#'4'
        movx    @dptr,a

        mov     bpu,#BPU2400    ; ᫮   10 
        mov     is_psk,#1       ; PSK 

        jmp     i_zeroes


i_n2400:

        mov     a,#'4'                  ; 4800 
        movx    @dptr,a
        inc     dptr
        mov     a,#'8'
        movx    @dptr,a

        mov     bpu,#BPU4800    ; ᫮   10 
        mov     is_psk,#1       ; PSK 

i_zeroes:

        inc     dptr    ; 塞 '00'
        mov     a,#'0'
        movx    @dptr,a
        inc     dptr
        movx    @dptr,a

init_exit:
        ret

;-------------------------------------------------------------------------

; ஢ઠ 

check_ram:

        mov     dptr,#0

next:
        mov     a,#01010101b
        movx    @dptr,a         ; 襬   
        movx    a,@dptr         ; ࠧ  ⠥
        cjne    a,#01010101b,badram     ;  砥 ࠢ⢠ - 訡

        mov     a,#10101010b
        movx    @dptr,a         ; 襬   
        movx    a,@dptr         ; ࠧ  ⠥
        cjne    a,#10101010b,badram     ;  砥 ࠢ⢠ - 訡

        cpl     NRZO    ;   ᨬ...

        inc     dptr             ; 騩 
        mov     a,dpl
        jnz     next
        mov     a,dph
        cjne    a,#high(RAM_SIZE),next


; ࣠ DCD

        clr     DCD
        mov     dptr,#0
blink:
        cpl     NRZO
        djnz    dpl,blink
        djnz    dph,blink
        setb    DCD
        mov     dptr,#0
blink1:
        cpl     NRZO
        djnz    dpl,blink1
        djnz    dph,blink1
        clr     DCD

        ret                     ;   - 頥

badram:

        mov     r1,#20
        mov     dptr,#0
foo:
        cpl     NRZO    ;   ᨬ...

        djnz    dpl,foo
        djnz    dph,foo

        cpl     DCD  ; 㥬 ᨣ DCD

        djnz    r1,foo
forever:
        jmp     forever ;    


;-------------------------------------------------------------------------

; ஢ઠ ⥪  ९

check_stack:

        push    ACC

        mov     a,stk_check        ; ஢塞    ⥪
        cjne    a,#0FFh,wd_reset
        mov     a,stk_check+1
        cjne    a,#0FFh,wd_reset

        pop     ACC
        ret

wd_reset:
        clr     EA      ; ९ ⥪ - 뢠 १ watchdog

wd_reset_1:
        cpl     DCD
        jmp     wd_reset_1

;-------------------------------------------------------------------------

;    ஫쭮 㬬 x^16+x^15+x^2+1
; ࠭  ka9q NOS

crc_tab = $
        dw        00000h,01189h,02312h,0329Bh,04624h,057ADh,06536h,074BFh
        dw        08C48h,09DC1h,0AF5Ah,0BED3h,0CA6Ch,0DBE5h,0E97Eh,0F8F7h
        dw        01081h,00108h,03393h,0221Ah,056A5h,0472Ch,075B7h,0643Eh
        dw        09CC9h,08D40h,0BFDBh,0AE52h,0DAEDh,0CB64h,0F9FFh,0E876h
        dw        02102h,0308Bh,00210h,01399h,06726h,076AFh,04434h,055BDh
        dw        0AD4Ah,0BCC3h,08E58h,09FD1h,0EB6Eh,0FAE7h,0C87Ch,0D9F5h
        dw        03183h,0200Ah,01291h,00318h,077A7h,0662Eh,054B5h,0453Ch
        dw        0BDCBh,0AC42h,09ED9h,08F50h,0FBEFh,0EA66h,0D8FDh,0C974h
        dw        04204h,0538Dh,06116h,0709Fh,00420h,015A9h,02732h,036BBh
        dw        0CE4Ch,0DFC5h,0ED5Eh,0FCD7h,08868h,099E1h,0AB7Ah,0BAF3h
        dw        05285h,0430Ch,07197h,0601Eh,014A1h,00528h,037B3h,0263Ah
        dw        0DECDh,0CF44h,0FDDFh,0EC56h,098E9h,08960h,0BBFBh,0AA72h
        dw        06306h,0728Fh,04014h,0519Dh,02522h,034ABh,00630h,017B9h
        dw        0EF4Eh,0FEC7h,0CC5Ch,0DDD5h,0A96Ah,0B8E3h,08A78h,09BF1h
        dw        07387h,0620Eh,05095h,0411Ch,035A3h,0242Ah,016B1h,00738h
        dw        0FFCFh,0EE46h,0DCDDh,0CD54h,0B9EBh,0A862h,09AF9h,08B70h
        dw        08408h,09581h,0A71Ah,0B693h,0C22Ch,0D3A5h,0E13Eh,0F0B7h
        dw        00840h,019C9h,02B52h,03ADBh,04E64h,05FEDh,06D76h,07CFFh
        dw        09489h,08500h,0B79Bh,0A612h,0D2ADh,0C324h,0F1BFh,0E036h
        dw        018C1h,00948h,03BD3h,02A5Ah,05EE5h,04F6Ch,07DF7h,06C7Eh
        dw        0A50Ah,0B483h,08618h,09791h,0E32Eh,0F2A7h,0C03Ch,0D1B5h
        dw        02942h,038CBh,00A50h,01BD9h,06F66h,07EEFh,04C74h,05DFDh
        dw        0B58Bh,0A402h,09699h,08710h,0F3AFh,0E226h,0D0BDh,0C134h
        dw        039C3h,0284Ah,01AD1h,00B58h,07FE7h,06E6Eh,05CF5h,04D7Ch
        dw        0C60Ch,0D785h,0E51Eh,0F497h,08028h,091A1h,0A33Ah,0B2B3h
        dw        04A44h,05BCDh,06956h,078DFh,00C60h,01DE9h,02F72h,03EFBh
        dw        0D68Dh,0C704h,0F59Fh,0E416h,090A9h,08120h,0B3BBh,0A232h
        dw        05AC5h,04B4Ch,079D7h,0685Eh,01CE1h,00D68h,03FF3h,02E7Ah
        dw        0E70Eh,0F687h,0C41Ch,0D595h,0A12Ah,0B0A3h,08238h,093B1h
        dw        06B46h,07ACFh,04854h,059DDh,02D62h,03CEBh,00E70h,01FF9h
        dw        0F78Fh,0E606h,0D49Dh,0C514h,0B1ABh,0A022h,092B9h,08330h
        dw        07BC7h,06A4Eh,058D5h,0495Ch,03DE3h,02C6Ah,01EF1h,00F78h

;-------------------------------------------------------------------------

; , 뫠  ᫥  ஫

intro = $

; fm TNC to PC <UI>: KISS TNC is ready.
;                    Version #xx, SYNC=xxxx baud, ASYNC=xxxx baud

        db      0A0h,086h,040h,040h,040h,040h,060h,0A8h
        db      09Ch,086h,040h,040h,040h,0E1h,003h,0F0h

        db      'KISS TNC is ready.'
        db      13,'Version K469/SIB'
        db      13,'Sync = '
intro_speed = $
        db      'BAD! baud'
        db      13
        db      0,0     ;  ஫쭮 㬬 -  ࠢ 모뢠

intro_end = $

;-------------------------------------------------------------------------

        end

